"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const graphql_middleware_1 = require("graphql-middleware");
const permissions_1 = require("./permissions");
const rules_1 = require("./rules");
function normalizeOptions(options = {}) {
    const { debug = false, authenticatedRule = rules_1.defaultAuthenticatedRule, } = options;
    return { debug, authenticatedRule };
}
function permissions(permissionsRules, _options) {
    return graphql_middleware_1.middleware((schema) => {
        const options = normalizeOptions(_options);
        return permissions_1.validatePermissions(schema, permissionsRules, options);
    });
}
exports.permissions = permissions;
// Exemple
// const permissionsSetup: Permission[] = [
//   {
//     operation: 'User.Read',
//     authenticated: true,
//     alias: 'me',
//   },
//   {
//     operation: 'User.Read',
//     authenticated: true,
//     fields: ['password', 'email'],
//     // rule: () => {},
//   },
//   {
//     operation: 'User.Browse',
//     authenticated: true,
//     alias: 'users',
//   },
//   {
//     operation: 'User.Edit',
//     authenticated: true,
//     alias: 'updateCurrentUser',
//     // fields: ['email'],
//     // rule: isOwner,
//   },
//   {
//     operation: 'UserSpace.Read',
//     authenticated: true,
//     fields: ['slug'],
//     // rule: () => { },
//     // query: ownerUserSpace,
//   },
//   {
//     operation: 'UserSpace.Browse',
//     authenticated: true,
//     alias: 'spaces',
//     // rule: () => { },
//     // query: ownerUserSpace,
//   },
//   {
//     operation: 'UserSpace.Add',
//     authenticated: true,
//   },
//   {
//     operation: 'UserSpace.Edit',
//     authenticated: true,
//     fields: ['slug'],
//     // rule: isOwner,
//     // query: ownerUserSpace,
//   },
//   {
//     operation: 'UserSpace.Delete',
//     authenticated: true,
//     // rule: isOwner,
//     // query: ownerUserSpace,
//   },
// ]
//# sourceMappingURL=index.js.map